/*ruby - 
copyright 2010 Chris Glasier 
coding advice by Jim Foltz
code check JSLint 24 September 2010

Bridges to Sketchup  */

//code check JSLint 24 September 2010

/*global
window,document,macHolders,macRun,fFinish,coreShutter
*/
var config, nset, nset, mset;

function rubyMerge(o, ob) {
	for (var z in ob) {
        if (ob.hasOwnProperty(z)) {
			o[z] = ob[z];
        }
    }
    return o;
}

function rubyChangeRec(json){
    var nset2, a, b;
    nset2 = JSON.parse(json);
    a = nset;
    b = nset2;
    nset = rubyMerge(a, b);
}


function rubyChange(node) {
    var oldName, nset1, nset2, nset0, nt, cut, n, txt, arr;
    if (node === config.header) {
        return;
    }
    oldName = config.header;
    config.header = node;
    nset1 = {};	// new front end
    nset2 = {}; //old shared Json
    nt = config.nametrail;
    cut = nset[node].Backlink[0];
    for (n in nset) {
		chk = n.charAt(0) + n.charAt(1);
		//if node is for front end
		if(n.charAt(0) === "z"){
			nset1[n] = nset[n];	
		}
		//transfers old project nodes for filing
		else {
            nset2[n] = nset[n];
        }
	}
    txt = JSON.stringify(nset2);
    arr = [node, oldName, txt];
    document.getElementById("trans").value = arr.join("|");
    nset = nset1;
    window.location = "skp:change";
}

//start instead of onload;

window.location = "skp:send@" + "0";
   
function rubyReceive(ret) {
	var nr,json,pan;
    ret = ret.split("qq");
    nr = parseInt(ret[0],10);
    json = ret[1];
    switch (nr) {
		case 0: config = JSON.parse(json);	break;
		case 1: nset = JSON.parse(json);	break;
		case 2: mset = JSON.parse(json);    break;
	}
	nr += 1;
	if (nr < 3) {
		window.location = "skp:send@" + nr.toString();
	} 
	else {
		config.colwidth = document.body.offsetWidth / config.columns;
		config.stripetop = Math.floor(document.body.offsetHeight / 2);
		corePurge(); 
		macHolders();
		macRun();
		//window.onbeforeunload = rubyFinish; disabled during development
		
	}
}

function rubyFinish() {
	var list, fn, arr, a;
	 if (config.opendevice) {
			delete config.opendevice;
            fFinish();					//to clear device config variables
        }
	
    list = [config, nset];
    fn = ["config", "nset"];
    arr = [];
    for (a = 0; a < list.length; a += 1) {
        arr[a] = [fn[a], JSON.stringify(list[a])];
        arr[a] = arr[a].join(";");
    }
	coreShutter(2);
    document.getElementById("trans").value = arr.join("|");
	window.location = "skp:save";
}


	
	
	
	