/*machine - 
Start at page bottom 
copyright 2010 Chris Glasier 
coding advice by Jim Foltz
code check JSLint 24 September 2010

A special device that uses the core funtions to manage
the display and devices  */

/*global 
config,mset,nset,coreNsetSlider,document,coreAnimate,coreSliderHolder,coreMenuSlider,rubyFinish, coreShutter,coreInpboxHide,fList,coreDeviceSlider
*/

function macSort(list){
	var v, h,n;
	v = []; h=[];
	for(n in list){
		if(nset[list[n]].hasOwnProperty("Filter")){
			h.push(list[n]);
		}
		else{
			v.push(list[n]);
		}
	}
	return(v.concat(h));
}

function macNsetSlider(c){
	var ent,nt,flist,list;
	nt = config.nametrail;
	ent = nset[nt[c][0]]; //alert(JSON.stringify(nset[nt[c][0]]))
	flist = ent.Forelink;					
	if(config.view){
		list = macSort(flist);
	}
	else{
		list = flist;
	}
	coreNsetSlider(list, c);
}

function macSliderLeft(){	
	var f,nt,cl,mc,cw,left,lst,obj,elm,start,fin,sp; 
	f = config;
	nt = f.nametrail;
	cl = f.columns;
	mc = f.menucolumns;
	cw = f.colwidth;
	if(nt.length > cl - mc){
		left = nt.length - (cl - mc);
	}
	else{
		left = 0;
	} 
		lst		= nt[nt.length-1][0];
	if(nset[lst].Forelink === undefined && nt.length > cl - mc ){
		left -= 1; 
	}
	left	= left * cw;
	obj		= document.getElementById("nold");
	elm		= "left";
	start	= obj.offsetLeft;
	fin		= -left;
	sp		= f.animate;
	coreAnimate(obj , elm , start , fin , sp, 20, 0 );
}

function macHolders(){ 
	var f,cl,dt,nt,mc,mt,cw,st,arr,a,par,s,b,t,tt;
	f	= config;
	cl	= f.columns;
	dt	= f.devicetrail;
	nt	= f.nametrail;
	mc	= f.menucolumns;
	mt	= f.menutrail;
	cw	= f.colwidth;
	st	=  f.stripetop;
	arr = [["mold", cl-mc, mc, mt],["dold", cl-mc, mc, dt]];
	for(a=0; a<arr.length; a+=1){
		par = document.getElementById(arr[a][0]);
		s = par.style;
		s.left = arr[a][1] * cw + "px";
		s.width = arr[a][2] * cw + "px";
		for(b = 0; b < arr[a][2]; b += 1){
			if(arr[a][0] === "dold"){
				t = st;
			}
			else{
				tt = arr[a][3];
				t = st - tt[b][1];
			}
			coreSliderHolder(b, arr[a][0], t);
		}
	}
}	

function macRun(){
	var c,nt,t,mt; 
	nt = config.nametrail;
	document.getElementById("nold").innerHTML = "";
	for(c = 0 ; c < nt.length ; c+=1){
		t = config.stripetop - nt[c][1]; 
		coreSliderHolder(c, "nold", t);
		macNsetSlider(c);
	} 
	macSliderLeft();
	if(!config.opendevice){
		mt = config.menutrail;
		coreMenuSlider(0); 
	}
}

function noldDown(prms){			//prms = cell ,  sliderName , sliderNo , cnt , fin
	var f,ch,cl,cw,mc,nt,st,cell,node,sName,sNo,cs,cnt,fin,pan,nNo,dv,lst,par,coll,cplt;
	f		= config;
	ch		= f.cellheight;
	cl		= f.columns;
	cw		= f.colwidth;
	mc		= f.menucolumns;
	nt		= f.nametrail;
	st		= f.stripetop;
	cell	= prms[0];
	node	= cell.id.slice(1);
	sName	= prms[1];
	sNo		= prms[2];
	cnt		= prms[3];
	fin		= prms[4]; 
	pan		= "nold";
	nNo		= parseInt(sNo,10) + 1; 
	dv		= "nold";
	if(config.opendevice){
		coreInpboxHide()
		coreShutter(1);
	}
	if(nset[node].Type === "Nset"){
		rubyChange(node);
	}
	if(nset[node].Name === "NSET" ){
		if(config.view){
			delete config.view;
			for(n in nset){
				if(nset[n].hasOwnProperty("Filter")){
					delete nset[n].Filter;
				}
			}
		}
	}
	if(nset[node].Type.charAt(0) === "z" ){
		if(config.view){
			delete config.view;
		}
	}
	if(nset[node].Type === "Scene" ){
		config.view = node;
		nset[node].Forelink = nset.NSET.Forelink;
		for(n in nset){
			if(nset[n].hasOwnProperty("Filter")){
				delete nset[n].Filter;
			}
		}
		list = nset[node].Hidden;
		for(l in list){
			nset[list[l]].Filter = 1;
		}
	}
	if(sNo < nt.length-1){
		nt		= nt.slice(0,nNo);
	
	//removes surplus sliders
	
	//	if(nset[node].Forelink){
			par		= cell.parentNode.parentNode;
			coll	= par.childNodes;
			while(coll.length > nNo){
				par.removeChild(coll[coll.length-1]);
			}
		}
	//}	
	nt[nt.length-1][1] = st - fin;
	cplt	= [node,0];
	nt.push (cplt);
	
	//adds new slider if selection has children
	config.nametrail = nt;
	if(nset[node].Forelink){
		coreSliderHolder(nNo, "nold", config.stripetop);
		macNsetSlider(nNo);
	}
	macSliderLeft();
}

//menu prompts
	
function mold0Down(prms){	//prms = cell ,  sliderName , sliderNo , cnt , fin
	var mt,st,cell;
	st = config.stripetop;
	mt = config.menutrail;
	if(prms[0].innerHTML === "Save"){
		if(prms[3] === 0){								//first click
			document.getElementById("mold1").innerHTML = "";
		}
		else{
			rubyFinish();
		}
		return;
	}
	document.getElementById("mold1").style.top = config.stripetop +"px";
	mt[0][1] =  st - prms[4];
	cell = prms[0];
	mt[1] = [cell.id.slice(1),0];
	config.menutrail = mt; 
	coreMenuSlider(1);
	coreShutter(2);
}

function deviceInitiator(args){
	var holder,obj,list,c,pan;
	holder = document.getElementById("deviceScript");
	holder.innerHTML = "";
	obj = document.createElement("script");
	holder.appendChild(obj);
	obj.src = args + ".js";
	config.opendevice = args;
	coreInpboxHide();
	list	= fList("Main");
	coreShutter(1);
	c = 0;
	coreDeviceSlider(c,list);
	pan = document.getElementById("dold0");
	pan.firstChild.className = "dbgc";
}	

function mold1Down(prms){
	var f,mt,node,st,lst,mid,name,args;
	f = config;
	mt		= f.menutrail;
	node	= prms[0].id.slice(1);
	st		= Math.round(document.body.clientHeight/2);
	mt[1][1]= st - prms[4];
	config.menutrail = mt;	
	lst		= mt[1][0]; 
	mid		= mset[lst].Name;
	name	= mset[node].Name;
	if(prms[3] === 1){				//2nd click
		if(config.opendevice){
			fFinish();
		}
		args = mid.toLowerCase()+name;
		deviceInitiator(args);
	}
}

function moldDown(prms){	
	if(prms[2] === 0){
		mold0Down(prms);
	}
	else{
		mold1Down(prms);
	}
}







