#Copyright 2010, Chris Glasier 
#Code advice by Jim Foltz

require 'sketchup.rb'

if (not file_loaded?("nameset.rb"))
    UI.menu("Plugins").add_item("Nameset" ){ NsetSketchupMod.start }
end

module NsetSketchupMod
	def NsetSketchupMod.start
		
		Sketchup.send_action "selectSelectionTool:"
		
	@dlg = UI::WebDialog.new("Nameset", false, "Nameset", 375, 191, 0, 0, false)
		# non resizabble @ stage 0
        fileName = "nameset.html"
	@dlg.set_size 375,191	# overrides registry to keep consistent for video
    @dlg.set_file File.join(File.dirname(__FILE__), fileName)
		
	@dlg.add_action_callback("send") { |d, a|
			nr = Integer(a)
			p nr
			#subDir = "nset/"
			files = ["config","nset","mset","words","numbers"]
			lines = []
			file = File.join(File.dirname(__FILE__), files[nr] + ".json")
			p file
			File.open(file, 'r') do |f1|
				while line = f1.gets  
					lines.push line  
				end
			end 
			array = [nr,lines]
			array = array.join("qq")
			#p array
			script = "rubyReceive('#{array}')";
			d.execute_script(script)
		}	
		
	@dlg.add_action_callback("change") { |d, a|
			rec = @dlg.get_element_value("trans")
			rec = rec.split("|")
			newFile = rec[0]
			oldFile	= rec[1]
			oldJson = rec[2]
			p "newFile " + newFile
			p "oldFile " + oldFile
			p "oldJson " + oldJson
			#subDir = "nset/"
			#file = newFile
			#file = File.join(File.dirname(__FILE__), file +".skp")
			#p file
			#Sketchup.open_file file
			oldFile = File.join(File.dirname(__FILE__), oldFile +".json")
			f = File.open(oldFile, 'w')
			f.write oldJson
			f.close
			file = newFile
			file = File.join(File.dirname(__FILE__),  file + ".json")
			p file
			f = File.open(file, 'r') 
			line = f.gets
			f.close
			script = "rubyChangeRec('#{line}')";
			d.execute_script(script)
		}	
		
	@dlg.add_action_callback("save") { |d, a|
		p = @dlg.get_element_value("trans")
		recs = p.split("|")
		recs.each do | rec |
			rec = rec.split(";")
			name = rec[0]
			json = rec[1]
			file = File.join(File.dirname(__FILE__), name +".json")
			f = File.open(file, 'w')
			f.write json
			f.close
			
		end
	}

	def self.is_mac?
		return (Object::RUBY_PLATFORM =~ /darwin/i) ? true : false
	end	
	
	
		
	#	@dlg.set_on_close{ |d, a|
	#		@dlg.execute_script("macFinish()")
	#	}
		if is_mac?
			@dlg.show_modal
		else
			@dlg.show
		end
       
	end # def nsetSketchupMod.start

end # module nsetSketchupMod

file_loaded("nameset.rb")
