/*
nameNames -Start at page bottom 
copyright 2010 Chris Glasier 
code check JSLint 24 September 2010
*/

/*global 
config,nset,mset,words,numbers,coreLength,macRun,coreInpboxHide,coreDeviceSlider,coreShutter,document 
*/
function fList(name){
	var list;	
	switch(name){
		case "Main"	: list = ["Menu","ShowHide","Save"]; break;
		case "Save" : list = ["Confirm","Cancel"]; break;
	}
	return(list);
}

function fPass(ents, node, pass, ft){
	var nt,fn;
	pass += 1;
	if(ents[pass] === undefined){
		return;
	}
	node = ents[pass];
	if(nset[node].Forelink){
		fCompile(ents , node , pass, ft);
	}
	else{
		fPass(ents, node, pass, ft);
	}
}

function fCompile(ents, node, pass, ft){
	var cell, k, kk;
	node	= ents[pass];
	k	= nset[node].Forelink; 
	for(kk = 0; kk < k.length; kk += 1){
		cell = document.getElementById("n"+k[kk]);
		if(ft === 1){
			nset[k[kk]].Filter = 1;
		}
		else{
			delete nset[k[kk]].Filter;
		}	
		ents.push(k[kk]);
	}
	fPass(ents, node, pass, ft);
}

function fLeader(nt,node){
	var pass,ents,hid,ft;
	pass = 0;
	ents = [];
	ents[pass] = [node];
	if(!nset[node].Filter){
		nset[node].Filter = 1;
		ft = 1;
	}
	else{
		delete nset[node].Filter;
		ft = 0;
		
	}	
	if(!nset[node].Forelink){
		fn = nt[nt.length-1][2];
		hid = []
		for(n in nset){
			if(nset[n].hasOwnProperty("Filter")){
				hid.push(n);
			}
		}
		nset[config.view].Hidden = hid;
	}
	else{
		
		fCompile(ents, node, pass, ft);
	}
}

function fShowHide(){
	var nt,node,den;
	nt = config.nametrail;
	node = nt[nt.length-1][0];
	if(config.view){
		if(nset[node].Type === "Set" || nset[node].Type === "Scene"){
			list = ["Denied"];
			coreDeviceSlider(1, list);
			coreShutter(0);
		}
		else{
			coreShutter(1);
			fLeader(nt,node);
			macRun();
		}
	}
}

function fSave(cell){
	rubyFinish();
	coreShutter(1);
}

function fOptions(cell,cnt,node){
	if(cnt === 0){
		return;
	}
	word = cell.id;
	if(word === "Cancel" || word === "Denied"){
		coreShutter(1);
	}
	else{
		eval("f"+config.newprompt)(cell);
	}
}	

function fPrompts(cell,cnt,node){
	var prop,s,list,nt;
	config.newprompt = cell.id;
	switch(cell.id){
		case "Menu" : 
		coreShutter(1);
		break;
		case "ShowHide" : 
		fShowHide();
		break;
		default: 
		coreShutter(0);
		list = fList(cell.id);
		coreDeviceSlider(1, list);
	}
}

function fFinish(){
	delete config.opendevice;
	delete config.newprompt;
	delete config.newoption;
}




